#include <cmath>
#include <cctype>
#include "expr.h"
#include "config.h"

using namespace std;

static void eraseblanks(string &s)
{
	unsigned a, b=s.size();
	for(a=0; a<b && s[a]==' '; ++a);
	s.erase(0, a);
}

class expr_const : public expr
{
	evaltype d;
public:
	expr_const(evaltype dd) : d(dd) { }
	virtual evaltype eval() const { return d; }
};
class expr_2op : public expr
{
protected:
	exprp ll, rr;
public:
	expr_2op(exprp l, exprp r) : ll(l), rr(r) { ok = r && r->ok; }
	virtual ~expr_2op() { }
};

class expr_huuto : public expr
{
	exprp l;
public:
	expr_huuto(exprp ll) : l(ll) { }
	virtual ~expr_huuto() { }
	virtual evaltype eval() const
	{
		evaltype v=1, d = l->eval();
		// FIXME
		while(d > 0) { v*=d; --d; }
		return v;
	}
};

#define class2a(name, oper) class expr_##name : public expr_2op { \
	  public: expr_##name(exprp ll, exprp rr ): expr_2op(ll, rr) { } \
	  virtual evaltype eval() const { return ll->eval() oper rr->eval(); } }
#define class2b(name, func) class expr_##name : public expr_2op { \
	  public: expr_##name(exprp ll, exprp rr ): expr_2op(ll, rr) { } \
	  virtual evaltype eval() const { return func(ll->eval(), rr->eval()); } }
	  
class2a(minus, -);
class2a(plus,  +);
class2a(times, *);
class2a(divid, /);
class2b(modul, fmodl);
class2b(expon, powl);

string expr_expect;

exprp expr::load(string &s, int base, int prio)
{
	eraseblanks(s);
	expr_expect = "expression";
	
	if(!s.size())return NULL;
	
	exprp left;
	
	if(s[0]=='(')
	{
		s.erase(0, 1);
		left = load(s, base, 0);
		eraseblanks(s);
		if(s[0] != ')')
		{
			expr_expect = "')'";
			return NULL;
		}
		s.erase(0, 1);
	}
	else if(s[0] == '-') // && prio < prio_nega -- this exception exists in qb also
	{
		s.erase(0, 1);
		left = new expr_minus(new expr_const(0), load(s, base, prio_nega));
	}
	else
	{
		// Whee, this is the biggest part
		// of the parser? Reading a number?
        evaltype d=0, kerta=1;
        bool piste=false, jotain=false;
		while(s.size())
        {
            unsigned n;
            char c = s[0];
            if(c >= '0' && c <= '9')
            {
                if(base < 10 && c-'0' >= base)
                {
                	jotain = false;
                	break;
                }
                n = c - '0';
            }
            else if(c >= 'A' && c <= 'Z')
            {
                if(base <= 10 || c-'A' >= base-10)
                {
                	jotain = false;
                	break;
                }
                n = c + (10 - 'A');
            }
            else if(c >= 'a' && c <= 'z')
            {
                if(base <= 10 || c-'a' >= base-10
                || (base > 36 && c-'a' >= base-36)
                  )
                {
                	jotain = false;
                	break;
                }
                if(base > 36)
                	n = c + (10 - 'a' + 26);
                else
                	n = c + (10 - 'a');
            }
            else
            {
                if(c != '.' || piste)break;
                piste = true;
                s.erase(0, 1);
                continue;
            }
            s.erase(0, 1);
            jotain = true;
            if(piste)
                d += n / (kerta *= base);
            else
                d = d*base + n;
        }
	    left = jotain ? new expr_const(d) : NULL;
	}
	if(!left)return NULL;
reop:
	if(!left->ok)return NULL;
	eraseblanks(s);
	if(!s.size())return left;
	if(s[0] == '!' && prio < prio_huuto) { s.erase(0, 1); left = new expr_huuto(left); goto reop; }
	if(s[0] == '-' && prio < prio_add) { s.erase(0, 1); left = new expr_minus(left, load(s, base, prio_add)); goto reop; }
	if(s[0] == '+' && prio < prio_add) { s.erase(0, 1); left = new expr_plus(left,  load(s, base, prio_add)); goto reop; }
	if(s[0] == '*' && prio < prio_times) { s.erase(0, 1); left = new expr_times(left,  load(s, base, prio_times)); goto reop; }
	if(s[0] == '/' && prio < prio_times) { s.erase(0, 1); left = new expr_divid(left,  load(s, base, prio_times)); goto reop; }
	if(s[0] == '%' && prio < prio_modulo) { s.erase(0, 1); left = new expr_modul(left,  load(s, base, prio_modulo)); goto reop; }
	if(s[0] == '^' && prio < prio_expon) { s.erase(0, 1); left = new expr_expon(left,  load(s, base, prio_expon)); goto reop; }
	return left;
}
